#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ThirdPluginOnlyCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ThirdPluginOnlyCFG> M_ThirdPluginOnlyCFG::msSingleton(nullptr);

int M_ThirdPluginOnlyCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ThirdPluginOnlyCFGData* M_ThirdPluginOnlyCFG::GetData(std::string PackageName)
{
	auto it = mMapData.find(PackageName);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<std::string, M_ThirdPluginOnlyCFGData>& M_ThirdPluginOnlyCFG::GetMapData()
{
	return mMapData;
}

void M_ThirdPluginOnlyCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ThirdPluginOnlyCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ThirdPluginOnlyCFGData data;
		data.mPackageName = element->Attribute("PackageName");
		data.mChannelID = element->Attribute("ChannelID");
		data.mPlatform = element->Attribute("Platform");
		data.mRemark = element->Attribute("Remark");
		if (mMapData.find(data.mPackageName) != mMapData.end())std::cout <<"data refind:" << data.mPackageName << std::endl;
		assert(mMapData.find(data.mPackageName) == mMapData.end());
		mMapData.insert(std::make_pair(data.mPackageName, data));
		element = element->NextSiblingElement();
	}
}

void M_ThirdPluginOnlyCFG::Load()
{
	Load("../Config/M_ThirdPluginOnlyCFG.xml");
}

M_ThirdPluginOnlyCFG* M_ThirdPluginOnlyCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ThirdPluginOnlyCFG());
	}
	return msSingleton.get();
}
